-----------------------------------------------------------------------------------------------------
-- Inicio Script 01 Junio 2012 Carolina Olarte 	                                                   --
-- Actualizacion menu para quitar obligatoriedad en carta de entrega                               --
-----------------------------------------------------------------------------------------------------

--Actualiza la no obligatoriedad en la carta de entrega en etapa 5
UPDATE Menu
SET opcional= 1
WHERE idMenu in ('04040505','0404050501')

--Actualiza la no obligatoriedad en la carta de entrega en etapa 6
UPDATE Menu
SET opcional= 1
WHERE idMenu in ('0404060205','040406020501','0404060304','040406030401','04040604','0404060401')

--Actualiza la no obligatoriedad en la carta de entrega en etapa 7
UPDATE Menu
SET opcional= 1
WHERE idMenu in ('0404070205','040407020501','0404070304','040407030401','04040705','0404070501')

--Actualiza la no obligatoriedad en la carta de entrega en etapa 8
UPDATE Menu
SET opcional= 1
WHERE idMenu in ('0404080103','040408010301','0404080203','040408020301','0404080303','040408030301')


------------------------------------------------------------------------------------------
-- Fin Script 01 JUNIO 2012 Carolina Olarte	                  	                        --
------------------------------------------------------------------------------------------

-----------------------------------------------------------------------------------------------------
-- Inicio Script 04 Junio 2012 Carolina Olarte 	                                                   --
-- Scripts para historial de Backups                                                               --
-----------------------------------------------------------------------------------------------------

IF (SELECT COUNT(*) FROM INFORMATION_SCHEMA.TABLES 
WHERE TABLE_TYPE = 'BASE TABLE' 
AND TABLE_NAME = 'HistorialBackup' )= 0

CREATE TABLE HistorialBackup
(idBackup int IDENTITY (1,1) ,
DescripcionBackup varchar(250) NOT NULL,
comentarios varchar(1000) NULL,
fecha datetime NOT NULL,
idUsuario int NOT NULL
CONSTRAINT idBackup_pk PRIMARY KEY (idBackup)
)
GO

IF NOT EXISTS (SELECT * FROM sysobjects WHERE id = object_id(N'[FK_Usuario_HistorialBackup]') 
	AND OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[HistorialBackup] ADD CONSTRAINT [FK_Usuario_HistorialBackup] 
FOREIGN KEY ([idUsuario]) REFERENCES [dbo].[Usuario] ([idUsuario]) ON DELETE CASCADE 
GO

--Adiciona las opciones de menu para las copias de seguridad

insert into menu (idMenu, descripcion, enlace, opcional) values ('040103',	'Copias de Seguridad',	'NULL',	'1')
insert into menu (idMenu, descripcion, enlace, opcional) values ('04010301' ,	'Base datos completa',	'~/audSeguridad/Backups.aspx',	'1')
GO

insert into Pagina (nombre, rutaCompleta, idPadre, modulo, idMenu)
values ('Pagina', 'Ruta', 0, 'Modulo', '040103')
GO

insert into PaginaPerfil (idPagina, idPerfil)
select max(idPagina), 13
  from Pagina
GO

insert into PaginaPerfil (idPagina, idPerfil)
select max(idPagina), 16
  from Pagina
GO

insert into Pagina (nombre, rutaCompleta, idPadre, modulo, idMenu)
values ('Pagina', 'Ruta', 0, 'Modulo', '04010301')
GO

insert into PaginaPerfil (idPagina, idPerfil)
select max(idPagina), 13
  from Pagina
GO

insert into PaginaPerfil (idPagina, idPerfil)
select max(idPagina), 16
  from Pagina
GO

insert into Pagina (nombre, rutaCompleta, idPadre, modulo, idMenu)
values ('Backups.aspx', 'audSeguridad/Backups.aspx', 0, 'audSeguridad', '04010301')
GO

insert into PaginaPerfil (idPagina, idPerfil)
select max(idPagina), 13
  from Pagina
GO

insert into PaginaPerfil (idPagina, idPerfil)
select max(idPagina), 16
  from Pagina
GO
-- 
-- Procedimiento para Copia de base de datos completa
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [dbo].[SP_GeneraBackupBDCompleto] (@Ruta varchar(1000),@idUsuario as int,@comentarios as varchar(1000)) AS
DECLARE @Mensaje VarChar(2000)
, @fecha varchar(20)
, @Hora varchar(20)
, @archivo varchar(250)
, @base varchar(200)
, @NombreBackup varchar(1000)

BEGIN 
 
 SET @Fecha=convert(varchar(10),getdate(),112)
 SET @Hora= convert(varchar(10),Datename(Hour,getdate()),108)+'_'+convert(varchar(10),datepart(mi,getdate()),108)+'_'+convert(varchar(10),datepart(ss,getdate()),108)
 SELECT @base = db_name()   
 SELECT @NombreBackup ='AudiRisk_'+@Fecha+'_'+@Hora+'.bak'
 SET @archivo=@Ruta+'\'+@NombreBackup

 BACKUP DATABASE @base
 TO DISK = @archivo
 WITH noformat, init, NAME=N'BKP FULL de AUDIRISK', skip, norewind, nounload, stats=10

 INSERT INTO HistorialBackup (idUsuario,DescripcionBackup,comentarios,fecha) VALUES (@idUsuario,@NombreBackup,@comentarios,@Fecha)

END 
GO

------------------------------------------------------------------------------------------
-- Fin Script 04 JUNIO 2012 Carolina Olarte	                  	                        --
------------------------------------------------------------------------------------------


-----------------------------------------------------------------------------------------------------
-- Inicio Script 08 Junio 2012 Carolina Olarte 	                                                   --
-- Ajuste al desmarcar Escenarios en documentacion de amenazas                                     --
-----------------------------------------------------------------------------------------------------

-- Eliminar los hallazgos de auditoria que no deberian existir
DELETE
FROM HallazgosAuditoria
WHERE idHallazgo NOT IN (
SELECT idHallazgo
FROM HallazgosAuditoria H
INNER JOIN EstudioAmenazaEscenario EAE ON H.idEstudioAmenaza=EAE.idEstudioAmenaza AND H.idEstudioEscenario=EAE.idEstudioEscenario
WHERE H.idMenu= '040405'
)
GO

--Adicionar el campo idEstudioAmenazaEscenario a la tabla Hallazgos de Auditoria 
IF NOT EXISTS(SELECT * FROM information_schema.[columns] WHERE
table_name='HallazgosAuditoria' AND column_name='idEstudioAmenazaEscenario')
ALTER TABLE [dbo].[HallazgosAuditoria]
ADD [idEstudioAmenazaEscenario] int  NULL
GO

--Adicionar relacin a la tabla Hallazgos de Auditoria 
IF NOT EXISTS (SELECT * FROM sysobjects WHERE id = object_id(N'[FK_HallazgosAuditoria_idEstudioAmenazaEscenario]') 
	AND OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[HallazgosAuditoria] ADD CONSTRAINT [FK_HallazgosAuditoria_idEstudioAmenazaEscenario] 
FOREIGN KEY ([idEstudioAmenazaEscenario]) REFERENCES [dbo].[EstudioAmenazaEscenario] ([idEstudioAmenazaEscenario]) ON DELETE CASCADE 
go

--Actualizar el campo idEstudioAmenazaEscenario de la tabla Hallazgos de auditoria
  update h  
  set h.idEstudioAmenazaEscenario=EAE.idEstudioAmenazaEscenario  
  from HallazgosAuditoria h  
  INNER JOIN EstudioAmenazaEscenario EAE ON (H.idEstudioAmenaza=EAE.idEstudioAmenaza AND H.idEstudioEscenario=EAE.idEstudioEscenario)
  Where h.idMenu in ('040405')
GO

------------------------------------------------------------------------------------------
-- Fin Script 08 JUNIO 2012 Carolina Olarte	                  	                        --
------------------------------------------------------------------------------------------
